package application;
	

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.geometry.Pos;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.*;
import javafx.scene.paint.Color;
import javafx.scene.shape.Line;


public class Main extends Application {
	BorderPane root;
	TextField[][] textMatrix = new TextField[9][9];
	GridPane pane;
	int [][] arr;
	boolean go = false;
	boolean is_manual = false;
	boolean checkState = true;
	int rowErr = -1;
	int columnErr = -1;
	
	@Override
	public void start(Stage primaryStage) {
		try {
			 arr = new int[9][9];
			 root = new BorderPane();
			 pane = new GridPane();
			pane.setAlignment(Pos.CENTER);
			 drowBoard2(pane,arr);
			 
			 HBox optionBox = new HBox(40);
			 optionBox.setAlignment(Pos.CENTER);
			 Button easyLevel = new Button("Easy");
			 Button hardLevel = new Button("Hard");
			 Button manual = new Button("Manual");
 
			VBox levelBox = new VBox(10);
			levelBox.setAlignment(Pos.CENTER);
			levelBox.getChildren().addAll(easyLevel,hardLevel,manual);
			
			Button start = new Button("Start");
			
			
			Button solution = new Button("Solution");
			Button check = new Button("Check");
			VBox solutionBox = new VBox(10);
			solutionBox.setAlignment(Pos.CENTER);
			solutionBox.getChildren().addAll(solution,check);
			optionBox.getChildren().addAll(levelBox,start,solutionBox);
			root.setBottom(optionBox);
			
			easyLevel.setOnAction(e -> {
				arr = getStart(false);
				drowBoard2(pane,arr);
			});
			
			hardLevel.setOnAction(e -> {
				arr = getStart(true);
				drowBoard2(pane,arr);
			});
			
			manual.setOnAction(e -> {
				is_manual = true;
				for (int i = 0 ; i < 9 ; i++) {
					for (int j = 0 ; j < 9 ; j++) {
						textMatrix[i][j].setEditable(true);
					}
				}
			});
			
			start.setOnAction(e -> {
				go = true;
				is_manual = false;
				for (int i = 0 ; i < 9 ; i++) {
					for (int j = 0 ;j < 9 ; j++) {
						if (textMatrix[i][j].getText().equals("")) {
							textMatrix[i][j].setEditable(true);
						}
					}
				}
			});
			
			solution.setOnAction(e -> {
				Solution sol = new Solution();
				if (sol.solution(arr, pane)) {
					drowBoard2(pane,arr);
				//	drow(arr);
				}
			});
			
			
			check.setOnAction(e -> {
				if (isRight()) {
					Alert alert = new Alert(AlertType.INFORMATION);
					alert.setTitle("Information Dialog");
					alert.setHeaderText("Good job");
					alert.setContentText("Congratulation you solve it ! ");

					alert.showAndWait();
				} else {
					Alert alert = new Alert(AlertType.ERROR);
					alert.setTitle("Error Dialog");
					alert.setHeaderText("hummmmm");
					alert.setContentText("Ooops, Try Again :)");

					alert.showAndWait();
				}
			});
			
			
			
			 
			Scene scene = new Scene(root,500,600);
			scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
			primaryStage.setScene(scene);
			primaryStage.show();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void drow(int[][] arr) {
		for (int i = 0 ; i < 9 ; i++)  {
			for (int j = 0 ; j < 9 ; j++) {
				System.out.print(arr[i][j] + " ");
				
			}
			System.out.println();
		}
	}
	
	
	public void drowBoard2(GridPane p,int[][] arr) {
		
		
		for (int row = 0 ;  row < 3 ; row++ ) {
			for (int col = 0 ; col < 3 ; col++) {
				GridPane innerPane = new GridPane();
				innerPane.setStyle("-fx-background-color: BLUE, -fx-control-inner-background; -fx-background-insets: 1, 2; -fx-padding: 2;");
				for (int i = 0 ; i < 3 ; i++) {
					for (int j = 0 ; j < 3 ; j++) {
						TextField tf = new TextField();
						tf.setAlignment(Pos.CENTER);
						tf.setEditable(false);
						if (arr[i+row*3][j+col*3] != 0) {
							tf.setText(arr[i+row*3][j+col*3]+"");
						} 
						
						addEventHndler(tf);
						tf.setMaxWidth(40);
		                tf.setMinWidth(40);
		                tf.setMaxHeight(40);
		                tf.setMinHeight(40);
						tf.setStyle("-fx-control-inner-background:WHITE;");
						GridPane.setConstraints(tf, j, i);
		             
						innerPane.getChildren().add(tf);
						textMatrix[i+row*3][j+col*3] = tf;
					}
				}
				GridPane.setConstraints(innerPane, col, row);
				p.getChildren().add(innerPane);
			}
		}
		root.setCenter(p);
		System.out.println("sssss");
	}
	
	
	
	
	
	public int[][] getStart(boolean hard) {
		
		int[][] arr = new int[9][9];
		File in ;
		
		if (!hard) {
			int num = (int) Math.round(Math.random() + 1);
			in = new File("e" + num + ".txt");
		} else {
			int num = (int) Math.round(Math.random() + 1);
			in = new File("h" + num + ".txt");
		}
		
		try {
			Scanner scan = new Scanner(in);
			for (int i = 0 ; i < 9 ; i++)
				for (int j = 0 ; j < 9 ; j++)
					arr[i][j] = scan.nextInt();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return arr;
	}
	
	
	public void refresh() {
		for (int i = 0 ; i < 9 ; i++) {
			for (int j = 0 ; j < 9 ; j++) {
				if (textMatrix[i][j].getText().equals("")) {
					arr[i][j] = 0;
					
				} else {
					arr[i][j] = Integer.parseInt(textMatrix[i][j].getText());
				}
			}
		}
	}
	
	public Pairs getIndex(TextField t) {
	
		for (int i = 0 ; i < 9 ; i++) {
			for (int j = 0 ;j < 9 ; j++) {
				if (textMatrix[i][j] == t) 
					return  new Pairs(i,j);
			}
		}
		return new Pairs();
	}
	
	
	public void disableFields(boolean d) {
		for (int i = 0 ; i < 9 ; i++) {
			for (int j = 0 ; j < 9 ; j++) {
				textMatrix[i][j].setEditable(d);
			}
		}
	}
public void addEventHndler(TextField node) {
		
	
		
		node.textProperty().addListener(new ChangeListener<String>() {
			
			
			
		    @Override
		    public void changed(ObservableValue<? extends String> observable, String oldValue, 
		        String newValue) {
		    	if (go) {
		    		Pairs p = getIndex(node);
		    		if (!newValue.equals("") &&Character.isDigit(newValue.charAt(0)))
		    			refresh();
		    		if (!check(arr,p.x, p.y, newValue) ) {
		    			disableFields(false);
		    		} else {
		    			disableFields(true);
		    		}
		    		
		    		node.setEditable(true);
		    			
		    }
		    	
		    	if (is_manual && !newValue.equals("") && Character.isDigit(newValue.charAt(0))) 
		    		refresh();
		    	
		    	
		        if (!newValue.matches("\\d*")) {
		            node.setText(newValue.replaceAll("[^\\d]", ""));
		            
		        } else {
		        		System.out.println("Text changed from "+oldValue+" to "+newValue);
		        }
		        
		    
		    }
		});
		}


	public boolean check(int[][] arr,int row,int column , String value) {
		
		boolean r = vertifyRow(arr, row, column, value);
		boolean c = vertifyColumn(arr, row, column, value);
		boolean b = vertifyBox(arr, row, column, value);
		
		if (!(r && c && b)) {
			textMatrix[row][column].setStyle("-fx-control-inner-background: RED;");
		}
		
		return r && c && b;
	}
	
	
	public boolean vertifyColumn(int[][] arr,int row,int column,String value) {
		System.out.println("column = " + row +  "    " + column);
		boolean flag = false;
		for (int i = 0 ; i < 9 ; i++) {
			if (i != row) {
				if ( !value.equals("") &&textMatrix[i][column].getText().equals(value)) {
					columnError(column, "RED");
					flag = true;
					columnErr = column;
					return false;
				}
			}
		}
		columnErr = -1;
		if (!flag) 
			columnError(column, "WHITE");
		
		return true;
	}
	
	
	
	public void columnError(int column,String color) {
		
			for (int i = 0 ; i < 9 ; i++) {
				textMatrix[i][column].setStyle("-fx-control-inner-background: " + color + ";");
			}
		
	}
	
	public boolean vertifyRow(int[][] arr,int row,int column,String value) {
		System.out.println("row = " + row +  "    " + column);
		boolean flag = false;
		for (int i = 0 ; i < 9 ; i++) {
			if (i != column) {
				if (!value.equals("") && textMatrix[row][i].getText().equals(value)) {
					rowError(row, "RED");
					flag = true;
					rowErr = row;
					return false;
				}
			}
		}
		rowErr = -1;
		if (!flag)
			rowError(row, "WHITE");

		return true;
	}
	
	public void rowError(int row,String color) {
			
				for (int i = 0 ; i < 9 ; i++) {
					textMatrix[row][i].setStyle("-fx-control-inner-background: " + color + ";");
				}
			
	}
	
	public boolean vertifyBox(int[][] arr,int row,int column,String value) {
		
		int iRow = row - row%3;
		int jColumn = column - column%3;
		System.out.println("box = " + iRow +  "    " + jColumn + "   " + value);
		boolean flag = false;
		
		for (int i = 0 ; i < 3 ; i++) {
			for (int j = 0 ; j < 3 ; j++) {
				if ( !((i+iRow == row) && (j + jColumn == column) )) {
					if (!value.equals("") && textMatrix[i+iRow][j+jColumn].getText().equals(value)) {
						boxError(iRow, jColumn, "RED");
						flag = true;
						return false;
					}
				}
			}
			
		}
		
		if (!flag) {
			boxError(iRow, jColumn, "WHITE");
		}
		return true;
	}
	
	public void boxError (int row,int column, String color) {
		
			System.out.println(color);
			
			for (int i = 0 ; i < 3 ; i++) {
				
				for (int j = 0 ; j < 3 ; j++) {
					if (rowErr == -1 && columnErr == -1)
						textMatrix[i + row][j + column].setStyle("-fx-control-inner-background: " + color + ";");
					else {
						if (i+row == rowErr || j+column == columnErr) {
							
						} else {
							textMatrix[i + row][j + column].setStyle("-fx-control-inner-background: " + color + ";");
						}
					}
				}
			}
		
	}
	
	
	public boolean isRight() {
		refresh();
		for (int i = 0 ; i < 9 ; i++) 
			for (int j = 0 ; j < 9 ; j++) {
				if (arr[i][j] == 0)
					return false;
			}
		for (int i = 0 ; i < 9 ; i++)  {
			for (int j = 0 ;j < 9 ; j++) {
				boolean is = check(arr,i,j,arr[i][j]+"");
				if (!is) 
					return false;
				
			}
		}
		
		return true;
	}
	
	
	
	
	
	
	public static void main(String[] args) {
		launch(args);
	}
	
	
	
}
