package application;

import java.util.logging.Level;
import java.util.logging.Logger;

import javafx.application.Platform;
import javafx.scene.layout.GridPane;

public class Solution {
	

	boolean solution(int[][] arr,GridPane grid) {
		Pairs p = new Pairs();
		
		if (!isFull(arr,p))
			return true;
					
		System.out.println(p.x + "  " + p.y);
		for (int i = 1 ; i <= 9 ; i++) {
			if (isSafe(arr, p.x, p.y, i)) {
				arr[p.x][p.y] = i;

	           

			if (solution(arr,grid))
				return true;
			
			arr[p.x][p.y] = 0;
			
			}
		}
		return false;
			
	}
	

	
	
	boolean isFull(int[][] arr, Pairs p) {
		
		for (p.x = 0 ; p.x < 9 ; p.x = p.x + 1) {
			for (p.y = 0 ; p.y < 9 ; p.y = p.y + 1) {
				if (arr[p.x][p.y] == 0)
					return true;
			}
		}
		return false;
	}
	
	boolean isSafe(int[][] arr,int row,int column, int val) {
		return isColumnSafe(arr, column, val) 
				&& isRowSafe(arr, row, val)
				&& isBoxSafe(arr, row - row%3, column - column%3, val);
				
	}
	
	
	boolean isColumnSafe(int[][] arr,int column,int val) {
		for (int i = 0 ; i < 9 ; i++)
			if (arr[i][column] == val)
				return false;
		return true;
	}
	
	boolean isRowSafe(int[][] arr,int row,int val) {
		for (int i = 0 ; i < 9 ; i++)
			if (arr[row][i] == val)
				return false;
		return true;
	}
	
	boolean isBoxSafe(int[][] arr,int si,int sj,int val) {
		for (int i = 0 ; i < 3 ; i++)
			for (int j = 0 ; j < 3 ; j++)
				if (arr[i + si][j + sj] == val)
					return false;
		return true;
	}
	

}
